package codelet;

import org.jdom2.Document;
import org.jdom2.Element;
import org.jdom2.input.DOMBuilder;
import org.jdom2.output.XMLOutputter;
import org.xml.sax.InputSource;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import java.io.ByteArrayInputStream;
import java.util.Iterator;

/*
@author Simon Rempel
 */
public class XMLTransformer {

    //returns xml as string without root element
    //if there are no children return empty string
    public static String XMLtoStringWithoutRootElement(org.jdom2.Element element) throws Exception{

        //init vars
        String tmp = XMLtoString(element);
        String resultValue = "";

        //get XML as String
        Document doc = stringToXMLDocument(tmp);


        //get Iterator for all Children
        Iterator<Element> childrenIterator =  doc.getRootElement().getChildren().listIterator();

        //Iterate above all children and extract strings
        while(childrenIterator.hasNext()){
            resultValue = resultValue + XMLTransformer.XMLtoString(childrenIterator.next());
        }
        return resultValue;
    }

    //returns full xml as String
    public static String XMLtoString(org.jdom2.Element element) throws Exception{
        return new XMLOutputter().outputString(element);
    }

    //returns String as XML
    //designed in style of https://howtodoinjava.com/xml/parse-string-to-xml-dom/ by Lokesh Gupta
    public static org.jdom2.Document stringToXMLDocument(String inputData) throws Exception {

        if(inputData.equals("")){
            return new Document();
        }
        //get an w3c document builder
        DocumentBuilder builder = DocumentBuilderFactory.newInstance().newDocumentBuilder();

        //transform the input String to a w3c document
        org.w3c.dom.Document doc = builder.parse(new InputSource(new ByteArrayInputStream(inputData.getBytes("UTF-8"))));

        // build dom with the transformed document
        org.jdom2.Document result = new DOMBuilder().build(doc);

        return result;
    }

    public static Element stringToElement(String inputData) throws Exception {

        if(inputData.equals("")){
            return null;
        }

        return stringToXMLDocument(inputData).getRootElement();

    }
}


