package RuntimeEnv;

import exceptions.RPAExecutionException;
import org.openqa.selenium.WebDriver;
import rpa.ScriptModel;

import org.jdom2.Element;
import util.XMLTransformer;

import java.lang.reflect.Method;

public class RuntimeEnvironment {


    public static void setExecutionMethods() throws RPAExecutionException {

        for(Method method : ScriptModel.getStartingClass().getMethods() ){

            if(method.getName().equals("execute")){
                ScriptModel.setStartingMethod(method);
            }

            if(method.getName().equals("hasOutput")){
                ScriptModel.setOutputDataTypeCheck(method);
            }

            if(method.getName().equals("hasInput")){
                ScriptModel.setInputDataTypeCheck(method);
            }

            if(method.getName().equals("getOutputDataType")){
                ScriptModel.setOutputDataTypeMethod(method);
            }

            if(method.getName().equals("getInputDataType")){
                ScriptModel.setInputDataTypeMethod(method);
            }

        }
        if(ScriptModel.getStartingMethod() == null | ScriptModel.getOutputDataTypeMethod() == null | ScriptModel.getOutputDataTypeCheck() == null | ScriptModel.getInputDataTypeCheck() == null | ScriptModel.getInputDataTypeMethod() == null ){
            throw new RPAExecutionException("In this RPA Script there was a method left that was declared in AbstractSeleniumScript superclass");
        }
    }



    public static String execute(String root, String webDriver) throws RPAExecutionException {


        setExecutionMethods();



        try {
            return (String)
                     ScriptModel.
                            getStartingMethod().invoke(ScriptModel.getStartingClass().newInstance(), root, webDriver
                             );



        } catch (Exception e) {
            e.printStackTrace();
            throw new RPAExecutionException("Exception occured while executing RPA Script, log can give further advices");
        }


    }



}
