package rpa;

import RuntimeEnv.RuntimeEnvironment;
import org.jdom2.Element;
import org.openqa.selenium.WebDriver;

import java.lang.reflect.InvocationTargetException;

public class SeleniumScript extends AbstractSeleniumScript {

    @Override
    public boolean hasOutput() throws IllegalAccessException, InstantiationException, InvocationTargetException {

        Boolean result = (boolean) ScriptModel.getOutputDataTypeCheck().invoke(ScriptModel.getStartingClass().newInstance());
        return result.booleanValue();

    }

    @Override
    public boolean hasInput() throws IllegalAccessException, InstantiationException, InvocationTargetException {
        Boolean result = (boolean) ScriptModel.getInputDataTypeCheck().invoke(ScriptModel.getStartingClass().newInstance());
        return result.booleanValue();
    }

    @Override
    public String getOutputDataType() throws IllegalAccessException, InstantiationException, InvocationTargetException {
        String result = (String) ScriptModel.getOutputDataTypeMethod().invoke(ScriptModel.getStartingClass().newInstance());
        return result;
    }

    @Override
    public String getInputDataType() throws IllegalAccessException, InstantiationException, InvocationTargetException {
        String result = (String) ScriptModel.getInputDataTypeMethod().invoke(ScriptModel.getStartingClass().newInstance());
        return result;
    }

    @Override
    public String execute(String root, String driver) throws Exception {
        return (String) RuntimeEnvironment.execute(root, driver);
    }
}
