package util;

import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class PathExtractorForWebDriver {

    //if you want to change the Name of the .GeckoConfigYAWL-directory or GeckoConfig.xml you have to Adjust it here too
    private static String configXMLPath = System.getProperty(Filenames.HOME_DIRECTORY) + File.separator + Filenames.XML_CONFIG_DIRECTORY + File.separator + Filenames.XML_CONFIG_FILE;

    public static String getGeckoDriverPathFromUserDirectoryInConfigXML() {

        String resultPath = "";
        //Save Path to config XML file for extracting the needed file path
        // String dir = System.getProperty("user.dir");
        //load xml config file for extracting geckoDriver path

        File xmlFile = new File(configXMLPath);
        DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
        DocumentBuilder dBuilder;

        //some XML management
        try {
            dBuilder = dbFactory.newDocumentBuilder();
            Document doc = dBuilder.parse(xmlFile);
            doc.getDocumentElement().normalize();
            doc.getDocumentElement().getChildNodes().item(0).getTextContent();
            NodeList nodeList = doc.getElementsByTagName(Filenames.XML_CONFIG_ELEMENT_WEBDRIVER_PATH);
            resultPath = doc.getDocumentElement().getChildNodes().item(1).getTextContent();

        } catch (Exception e) {
            System.out.println("No gecko driver found in config xml because " + e.getMessage());
        }

        return resultPath;

    }

    public static List<String> getRPARepositoryFromUserDirectoryInConfigXML() {

        List<String> resultPathList = new ArrayList<String>();
        //Save Path to config XML file for extracting the needed file path
        // String dir = System.getProperty("user.dir");
        //load xml config file for extracting geckoDriver path

        File xmlFile = new File(configXMLPath);
        DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
        DocumentBuilder dBuilder;

        //some XML management
        try {
            dBuilder = dbFactory.newDocumentBuilder();
            Document doc = dBuilder.parse(xmlFile);
            doc.getDocumentElement().normalize();
            doc.getDocumentElement().getChildNodes().item(0).getTextContent();
            NodeList nodeList = doc.getElementsByTagName(Filenames.XML_CONFIG_RPA_FILE_PATH);


            for(int i = 0; i < nodeList.getLength(); i++){
                System.out.println("PathExtracotr" + nodeList.item(i).getTextContent());
                resultPathList.add(nodeList.item(i).getTextContent());
            }

           /* //resultPath = doc.getDocumentElement().getChildNodes().item(1).getTextContent();
            doc.getDocumentElement().getChildNodes().getLength();
            for(int i = 1; i < doc.getDocumentElement().getChildNodes().getLength(); i++){
                resultPathList.add(doc.getDocumentElement().getChildNodes().item(i).getTextContent());
            }*/
        } catch (Exception e) {
            System.out.println("No RPA-Script-Path found in config xml because " + e.getMessage());
        }

        return resultPathList;

    }

}
