package util;

import exceptions.NoOrFalseJarNameException;
import rpa.AbstractSeleniumScript;
import rpa.ScriptModel;

import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.net.URLClassLoader;
import java.nio.file.FileSystemNotFoundException;
import java.rmi.server.ExportException;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.List;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;

public class RPAClassLoader {


    public static AbstractSeleniumScript loadClassFromClassFiles(String className) throws IOException, ClassNotFoundException, NoOrFalseJarNameException, IOException {


        AbstractSeleniumScript rpaScript = null;

        List<String> rpaPaths = PathExtractorForWebDriver.getRPARepositoryFromUserDirectoryInConfigXML();
        int i = 1;
        //for every defined path of rpa JAR
        for (String path: rpaPaths
        ) {



            final URLClassLoader rpaClassLoader = new URLClassLoader (new URL[] {new URL( "file:///" + path)});

            try {

                // Getting the jar URL which contains target class
                URL[] classLoaderUrls = new URL[]{new URL("file:///" + path)};

                // Create a new URLClassLoader
                URLClassLoader urlClassLoader = new URLClassLoader(classLoaderUrls);

                // Load the target class
                Class beanClass =  urlClassLoader.loadClass(className);
                

                if(rpaScript != null){
                    return rpaScript;
                }

            } catch (Exception e) {
                e.printStackTrace();
            }


       }throw new ClassNotFoundException("Klasse nicht gefunden");
    }



    public static void loadClassFromJar(String nameOfClass) throws IOException, ClassNotFoundException, NoOrFalseJarNameException, IOException {

       // HashMap<String, AbstractSeleniumScript> rpaScripts = new HashMap<>();
        AbstractSeleniumScript script = null;

        List<String> rpaPaths = PathExtractorForWebDriver.getRPARepositoryFromUserDirectoryInConfigXML();
        int j = 0;
        //for every defined path of rpa JAR
        for (int i = 0; i < rpaPaths.size(); i++) {
            String pathToWatch = rpaPaths.get(i);
        try {
            String nameOfJAR ="";
            if(pathToWatch.substring(pathToWatch.length() -4).equals(".jar")){

                nameOfJAR = pathToWatch.substring(pathToWatch.lastIndexOf(File.separator) +1,
                        pathToWatch.length() -4 );
            } else {
               continue;
            }
            JarFile jarFile = new JarFile(pathToWatch);
            Enumeration<JarEntry> e = jarFile.entries();


            //in case of windows environment replace backslash with slash
            if(!File.separator.equals("/")){
                                pathToWatch = pathToWatch.replace("\\", "/");
            }

            URL[] urls = {new URL("jar:file:" + pathToWatch + "!/")};
            URLClassLoader cl = URLClassLoader.newInstance(urls);

            while (e.hasMoreElements()) {
                JarEntry je = e.nextElement();
                if (je.isDirectory() || !je.getName().endsWith(".class")) {
                    continue;
                }

                String classNameSystem = je.getName().substring(0, je.getName().length() - 6);
                classNameSystem = classNameSystem.replace(File.separatorChar, '.');
                String classNameRelative = classNameSystem.substring(classNameSystem.lastIndexOf("/") + 1);
                Class c = null;
                String classNameWithDots = classNameSystem.replace("/", ".");

               try{
                   if(classNameRelative.equals(nameOfClass)){
                       c = cl.loadClass(classNameWithDots);
                   } else{
                       continue;
                   }
               } catch (NoClassDefFoundError classLoadingException){
                   classLoadingException.printStackTrace();
                   continue;

               } catch (ClassNotFoundException classNotFound){
                   classNotFound.printStackTrace();
               }

               String superClassOfClass = c.getSuperclass().getCanonicalName();
               String absractSeleniumScriptName = AbstractSeleniumScript.class.getCanonicalName();

               if(c.getSuperclass().getCanonicalName().contains(".")){
                  superClassOfClass = c.getSuperclass().getCanonicalName().substring(c.getSuperclass().getCanonicalName().lastIndexOf(".") + 1);
               }

                if(absractSeleniumScriptName.contains(".")){
                    absractSeleniumScriptName = absractSeleniumScriptName.substring(absractSeleniumScriptName.lastIndexOf(".") + 1);
                }


                //initialize RPA-Script
                if (superClassOfClass.equals(absractSeleniumScriptName)) {

                    ScriptModel.setStartingClass(c);
                    ScriptModel.setName(classNameRelative);

                }

            }

        } catch (Exception e) {
            e.printStackTrace();

        }
        }
    } }
